//Interface to supported tablet APIs.
#include <array>
#include <string>

#ifdef YAW_USE_WINTAB
#include <Windows.h>
#include "MSGPACK.H"
#include "wintab.h"
#endif


struct Packet {
	float x;
	float y;
	float z;
	float p;
	unsigned long buttons;
	bool operator==(const Packet& p)
	{ return
		this->x == p.x &&
		this->y == p.y &&
		this->z == p.z &&
		this->p == p.p &&
		this->buttons == p.buttons;
	};
	bool operator!=(const Packet& p) { return !(*this == p); }
};

class Tablet {
public:
	Tablet(uintptr_t handle);
	~Tablet();
    bool GetPacket( Packet &pkt );
	bool initialized;
	std::string errormsg = "";

private:

	Packet ext = { 0 };

#ifdef YAW_USE_WINTAB
	void NewContext(HWND hwnd);
	HCTX hctx = NULL;
#endif
};